#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include "portbits.h"
#include "global.h"
#include "rf23.h"
#include <util/delay.h>

static inline unsigned char rf23_trans(unsigned char addr, unsigned char data)
{	
	CS=0;     //nsel = 0

	//Addresse auf den Chip schreiben
	SPDR = addr;   
	while(!(SPSR & (1<<SPIF)));   //SPSR...Statusregister
    //Daten auf den Chip schreiben
	SPDR = data;
	while(!(SPSR & (1<<SPIF)));
	CS=1;    //nsel = 1
	return SPDR;
}

void rf23_write(unsigned char addr, unsigned char data)
{
	rf23_trans(128|addr,data); //R//W bit auf 1 setztn
}

unsigned char rf23_read(unsigned char addr)
{
	return rf23_trans(addr&127,0);  //alle bits gleich, bis auf R//W auf 0
}

void rf23_spitest(void)
{
	DDRB|=0b11010000;      

	SPCR=(1<<SPE)|(1<<MSTR);	//spi enable, MSTR uC ist master -->clockrate=cpu/4
	SPSR|=(1<<SPI2X);           //clk/16

	_delay_ms(50);				// wait until POR done
    rf23_write(0x07, 0x80);		// software reset
	_delay_us(500);				// wait until software reset done

    rf23_write(0x05, 0x02);		// valid packed received interrupt on

    rf23_read(0x05);		//read0x02
}





